var Is = [];
var IIs = [];
var IIIs = [];

var IVs = [];
var Vs = [];
var	VIs = [];

var	VIIs = [];
var VIIIs = [];
var IXs = [];

var Xs = [];
var XIs = [];

var sylbArraysVar = [Is, IIs, IIIs, IVs, Vs, VIs, VIIs, VIIIs, IXs, Xs, XIs];

exports.I = Is;
exports.II = IIs;
exports.III = IIIs;

exports.IV = IVs;
exports.V = Vs;
exports.VI = VIs;

exports.VII = VIIs;
exports.VIII = VIIIs;
exports.IX = IXs;

exports.X = Xs;
exports.XI = XIs;

exports.sylbArrays = sylbArraysVar;


var returnline = "";
var finalHaiku = "";

function sylbcount(word) {
  word = word.toLowerCase();    
  if(word == 'shed') { return 1; }                                
  if(word.length <= 3) { return 1; }                            
    word = word.replace(/(?:[^laeiouy]es|ed|[^laeiouy]e)$/, ''); 
    word = word.replace(/^y/, '');                                 
    return word.match(/[aeiouy]{1,2}/g).length;                    
}



exports.count = function(word) {
	word = word.replace(/\d+/g,'').replace(/(\r\n|\n|\r)/gm,"").replace(/[^\w\s]|_/g, "").replace(/\s+/g, " ");
	return sylbcount(word);
}

exports.singleSort = function(thingToSort) {

	var sortarr = thingToSort.toString().replace(/\d+/g,'').replace(/(\r\n|\n|\r)/gm," ").replace(/[^\w\s]|_/g, "").replace(/\s+/g, " ").split(" ");
	
	sortarr.shift();
	
	for(i=0; i < sortarr.length; i++) {
 	  sylbArraysVar[ (sylbcount(sortarr[i])-1) ].push(sortarr[i]);
 	  
 	}
 	
}

exports.massSort = function(array) {

	array = array.join(' ').replace(/\d+/g,'').replace(/(\r\n|\n|\r)/gm," ").replace(/[^\w\s]|_/g, "").replace(/\s+/g, " ");
	array = array.split(' ');
		
		
 	for(i=0; i < array.length; i++) {
 	  sylbArraysVar[ (sylbcount(array[i])-1) ].push(array[i]);
 	}

}

exports.printDBWords = function() {
	console.log("[ SYLB ] :: Here are your cool words, sorted.");
	
	for(i=0; i<sylbArraysVar.length; i++) 
	{
		console.log(sylbArraysVar[i]);
	}
	
	

}

exports.printDBCount = function() {
	console.log("[ SYLB ]\n");
	for(i=0; i<sylbArraysVar.length; i++)
	{
		if(sylbArraysVar[i].length > 0) {
			console.log(sylbArraysVar[i].length + ' [' + (i+1) + '] syllable words');
		} else {
			console.log(sylbArraysVar[i].length + '!! [' + (i+1) + '] syllable words');
		}
	}
	console.log("\n[ SYLB ]");
}




// Haiku Generation


function intToArray(checkInt) {

	if( isNaN(checkInt) )
	{
		return;
	}
	
	var theArray = sylbArraysVar[ (checkInt-1) ];
	
	
	returnline += theArray[Math.floor(Math.random()*theArray.length)];
		
	returnline += ' ';	
}

function lineFromValArray(splitarr) {
	intToArray(splitarr[0]);
	intToArray(splitarr[1]);
	intToArray(splitarr[2]);
	intToArray(splitarr[3]);
	intToArray(splitarr[4]);
	intToArray(splitarr[5]);
	intToArray(splitarr[6]);
	
	
	//console.log('[' + splitarr + '] ' + returnline);
	
	finalHaiku += (returnline + "\n");
	
	returnline = "";
	
}

function getIntDividedIntoMultiple(dividend, divisor, multiple) {
    var values = [];
    while (dividend> 0 && divisor > 0)
    {
        var a = Math.round(dividend/ divisor / multiple) * multiple;
        dividend -= a;
        divisor--;
        values.push(a);
    }

    return values;
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


exports.sentence = function() {

	var theLine = "";
	
	

}

exports.haiku = function() {
	
	finalHaiku = "";
	
	lineFromValArray(getIntDividedIntoMultiple(5, getRandomInt(1, 5), 1))
	lineFromValArray(getIntDividedIntoMultiple(7, getRandomInt(1, 7), 1))
	lineFromValArray(getIntDividedIntoMultiple(5, getRandomInt(1, 5), 1))
	
	if(finalHaiku.includes('undefined')) {
		console.log("[ SYLB ] :: You don't have enough sorted words to generate a complete haiku.\n[ SYLB ] :: Try adding words with more syllables.\n")

	}
	
	return finalHaiku;
}
